/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package alaposztalyok;

import java.awt.Color;
import java.awt.Graphics;
import java.util.logging.Level;
import java.util.logging.Logger;
import vezerles.Vezerlo;

/**
 *
 * @author :)
 */
public class PirosSzal extends Thread implements Szal{

    private int kx, ky, vx, vy, aktx, akty, r;
    private double lepes ;
    private long ido;
    private Vezerlo vezerlo;
    private Color szin = Color.red;

    public PirosSzal(int kx, int ky, int vx, int vy, int r,
                   double lepes, long ido, Vezerlo vezerlo) {
        this.kx = kx;
        this.ky = ky;
        this.vx = vx;
        this.vy = vy;
        this.r = r;
        this.lepes = lepes;
        this.ido = ido;
        this.vezerlo = vezerlo;
    }   

    @Override
    public void run() {
        double szog = Math.atan2(vy - ky, vx - kx);
        double tavolsag = Math.sqrt((vy - ky)*(vy - ky) + (vx - kx)*(vx - kx));
        if (tavolsag > 0 && lepes > 0) {            
            
            for (double tav = 0; tav <= tavolsag; tav += lepes) {
                try {
                    aktx = (int) (kx + tav * Math.cos(szog));
                    akty = (int) (ky + tav * Math.sin(szog));
                    
                    Thread.sleep(ido);
                    vezerlo.frissit();
                } catch (InterruptedException ex) {
                    Logger.getLogger(PirosSzal.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
        }        
    }           

    @Override
       public void rajzolas(Graphics g){
        g.setColor(szin);
        g.fillOval(aktx-r, akty-r, 2*r, 2*r);
    }
}
